#include <stdio.h>
#include <stdlib.h>

char pbm[52][64];

#include "digits.c"

char circle[5][5]=
{ {'0','1','1','1','0'},
  {'1','0','0','0','1'},
  {'1','0','0','0','1'},
  {'1','0','0','0','1'},
  {'0','1','1','1','0'} };

char dot[5][5]=
{ {'0','1','1','1','0'},
  {'1','1','1','1','1'},
  {'1','1','1','1','1'},
  {'1','1','1','1','1'},
  {'0','1','1','1','0'} };


char cross[5][5]=
{ {'1','0','0','0','1'},
  {'0','1','0','1','0'},
  {'0','0','1','0','0'},
  {'0','1','0','1','0'},
  {'1','0','0','0','1'} };


void putgraph(char c[5][5],int y, int x)
{
  int i,j;

  for (i=0; i<5; i++)
    for (j=0; j<5; j++)
      pbm[y+i][x+j]=c[i][j];
};

void putdigit(int d,int y, int x)
{
  int i,j;

  for (i=0; i<DIGITHEIGHT; i++)
    for (j=0; j<DIGITWIDTH; j++)
      pbm[y+i][x+j]=digit[d][i][j];
};

void main(int argc,char *argv[])
{
  int x,y;
  int base,frets[6];

  if (argc!=8)
    exit(-1);

  if (sscanf(argv[1],"%d",&base)!=1)
    exit(-1);
  for (x=0; x<6; x++)
  {
    if (argv[2+x][0]<'0' || argv[2+x][0]>'4')
      frets[x]=-1;
    else if (sscanf(argv[2+x],"%d",&frets[x])!=1
             || frets[x]<0 || frets[x]>4)
           exit(-1);
  };
        
  for (y=0; y<52; y++)
    for (x=0; x<64; x++)
      pbm[y][x]='0';
  for (y=0; y<41; y++)
    for (x=0; x<41; x++)
      if (y%10 == 0 || x%8 == 0)
        pbm[y+9][x+19]='1';

  for (x=0; x<6; x++)
  {
    if (frets[x]<0)
      putgraph(cross,2,17+8*x);
    if (frets[x]==0)
      putgraph(circle,2,17+8*x);
    if (frets[x]>0 && frets[x]<=4)
      putgraph(dot,2+10*frets[x],17+8*x);
  };

  if (base>1 && base<100)
  {      
    x=base / 10;
    if (x!=0)
      putdigit(x,5,2);
    x=base % 10;
    putdigit(x,5,9);
  };

  printf("P1\n64 52\n");
  for (y=0; y<52; y++)
  { for (x=0; x<64; x++)
      printf("%c",pbm[y][x]);
    printf("\n");
  };
}
