/***************************************************************************
                          khordprodoc.cpp  -  description
                             -------------------
    begin                : gio feb 15 13:52:04 /etc/localtime 2001
    copyright            : (C) 2001 by Matteo Merli
    email                : merlim@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for Qt
#include <qdir.h>
#include <qwidget.h>

// include files for KDE
#include <klocale.h>
#include <kmessagebox.h>
#include <kio/job.h>
#include <kio/netaccess.h>

// application specific includes
#include "khordprodoc.h"
#include "khordpro.h"
#include "khordproview.h"


QList<KhordProView> *KhordProDoc::pViewList = 0L;

KhordProDoc::KhordProDoc(QWidget *parent, const char *name) : QObject(parent, name)
{
  if(!pViewList)
  {
    pViewList = new QList<KhordProView>();
  }

  pViewList->setAutoDelete(true);
}

KhordProDoc::~KhordProDoc()
{
}

void KhordProDoc::addView(KhordProView *view)
{
  pViewList->append(view);
}

void KhordProDoc::removeView(KhordProView *view)
{
  pViewList->remove(view);
}
void KhordProDoc::setURL(const KURL &url)
{
  doc_url=url;
}

const KURL& KhordProDoc::URL() const
{
  return doc_url;
}

void KhordProDoc::slotUpdateAllViews(KhordProView *sender)
{
  KhordProView *w;
  if(pViewList)
  {
    for(w=pViewList->first(); w!=0; w=pViewList->next())
    {
      //if(w!=sender)
        //w->repaint();
    }
  }

}

bool KhordProDoc::saveModified()
{
  bool completed=true;

  if(modified)
  {
    KhordProApp *win=(KhordProApp *) parent();
    int want_save = KMessageBox::warningYesNoCancel(win, i18n("Warning"),
                                         i18n("The current file has been modified.\n"
                                              "Do you want to save it?"));
    switch(want_save)
    {
      case 1:
           if (doc_url.fileName() == i18n("Untitled"))
           {
             win->slotFileSaveAs();
           }
           else
           {
             saveDocument(URL());
       	   };

       	   deleteContents();
           completed=true;
           break;

      case 2:
           setModified(false);
           deleteContents();
           completed=true;
           break;	

      case 3:
           completed=false;
           break;

      default:
           completed=false;
           break;
    }
  }

  return completed;
}

void KhordProDoc::closeDocument()
{
  deleteContents();
}

bool KhordProDoc::newDocument()
{
  /////////////////////////////////////////////////
  // TODO: Add your document initialization code here
  /////////////////////////////////////////////////
  modified=false;
  doc_url.setFileName(i18n("Untitled"));

  return true;
}

QString KhordProDoc::openDocument(const KURL& url, const char *format /*=0*/)
{
  QString tmpfile;
  KIO::NetAccess::download( url, tmpfile );

	Cpm2Html obj;
	QString htmlCode = obj.convert(tmpfile);
  
  KIO::NetAccess::removeTempFile( tmpfile );

  modified=false;
  return htmlCode;
}

bool KhordProDoc::saveDocument(const KURL& url, const char *format /*=0*/)
{
  /////////////////////////////////////////////////
  // TODO: Add your document saving code here
  /////////////////////////////////////////////////

  modified=false;
  return true;
}

void KhordProDoc::deleteContents()
{
  /////////////////////////////////////////////////
  // TODO: Add implementation to delete the document contents
  /////////////////////////////////////////////////

}
