/***************************************************************************
                          khordproview.h  -  description
                             -------------------
    begin                : gio feb 15 13:52:04 /etc/localtime 2001
    copyright            : (C) 2001 by Matteo Merli
    email                : merlim@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KHORDPROVIEW_H
#define KHORDPROVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

#include <khtml_part.h>

class KhordProDoc;

/** The KhordProView class provides the view widget for the KhordProApp instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As KhordProView is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the KhordProApp class to manipulate and display
 * the document structure provided by the KhordProDoc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class KhordProView : public KHTMLPart
{
  Q_OBJECT
  public:
    /** Constructor for the main view */
    KhordProView(QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~KhordProView();

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a KhordProApp instance as a parent
     * widget to get to the window document pointer by calling the KhordProApp::getDocument() method.
     *
     * @see KhordProApp#getDocument
     */
    //KhordProDoc *getDocument() const;

    /** contains the implementation for printing functionality */
    void print(QPrinter *pPrinter);
	
  private:
	
};

#endif // KHORDPROVIEW_H
