/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : gio feb 15 13:52:04 /etc/localtime 2001
    copyright            : (C) 2001 by Matteo Merli
    email                : merlim@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

#include "khordpro.h"
#include "version.h"

static const char *description =
	I18N_NOOP("KhordPro - a Chord Pro viewer");
	
	
static KCmdLineOptions options[] =
{
  { "+[File]", I18N_NOOP("file to open"), 0 },
  { 0, 0, 0 }
};

int main(int argc, char *argv[])
{

	KAboutData aboutData( "khordpro", I18N_NOOP("KhordPro"),
		K_VERSION, description, KAboutData::License_GPL,
		"(c) 2001, Matteo Merli - Alessandro Vernassa", 0, 0, "merlim@libero.it - speleoalex@libero.it");
	aboutData.addAuthor("Matteo Merli",0, "merlim@libero.it ");
 	aboutData.addAuthor("Alessandro Vernassa",0, "speleoalex@libero.it ");

  KCmdLineArgs::init( argc, argv, &aboutData );
	KCmdLineArgs::addCmdLineOptions( options ); 
	
  KApplication app;
 
  if (app.isRestored())
  {
    RESTORE(KhordProApp);
  }
  else 
  {
    KhordProApp *khordpro = new KhordProApp();
    khordpro->show();

    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
		
		if (args->count())
		{
        khordpro->openDocumentFile(args->arg(0));
		}
		else
		{
		  //khordpro->openDocumentFile();
		}
		args->clear();
  }

  return app.exec();
}  
